c
c-----------------------------------------------------------------------
c
      subroutine colorscale (x, cred, cgrn, cblu, zred, zgrn, zblu)
c
c.....colorscale - returns a rgb color based on the value of x. The
c     color scale follows approximately the scheme of the rainbow, being
c     blue for small values of x, red for high values, and yellowish
c     in between. The values of x should be restricted to the range
c     -1 <= x <=1, but no checking is done to enforce this. The
c     exponents zred, zgrn and zblu control the extension of the rgb
c     zones in such a way that colors are purer as the exponents are
c     higher. A good election would be zred=1, zgrn=3, zblu=1.
c
      real*8  x, cred, cgrn, cblu, zred, zgrn, zblu
c
      cred = 2d0 / (1d0 + exp(zred*(x-1d0)**2))
      cgrn = 2d0 / (1d0 + exp(zgrn*x*x))
      cblu = 2d0 / (1d0 + exp(zblu*(x+1d0)**2))
c
      end
