c
c-----------------------------------------------------------------------
c
      real*8 function energy (var, nv2)
c
c.....energy - determine the electrostatic energy of a set of +1 point
c     charges lying on the surface of a sphere of radius 1.
c
      include           'implicit.inc'
      include           'polyhedron.inc'
c
      integer           nv2
      real*8            var(nv2)
c
      integer           i, j, ii
      real*8            st, ene
      real*8            xij, yij, zij
c
c.....Determine angular coordinates of the starting points:
c
      do i = 1, nvert
         ii = nvert + i
         st = sin(var(i))
         cth(i) = cos(var(i))
         sthcph(i) = st * cos(var(ii))
         sthsph(i) = st * sin(var(ii))
      enddo
c
      ene = 0d0
      do i = 1, nvert
         do j = 1, i-1
            xij = sthcph(i) - sthcph(j)
            yij = sthsph(i) - sthsph(j)
            zij = cth(i) - cth(j)
            ene = ene + 1d0 / sqrt(xij*xij + yij*yij + zij*zij)
         enddo
      enddo
c
      energy = ene
      return
      end
