c
c-----------------------------------------------------------------------
c
      integer function fopen (u, filename, mode)
c
c.....fopen - open file and assign unique unit number.
c     assigned number returned thru both, fopen and u.
c
c     files can be opened in one of several modes:
c     ioread ......... read only access
c     iowrite ........ write access with ascii carriage control
c     ioappend ....... write access with append to existing file
c     iofortran ...... write access with fortran carriage control
c
      include           'strtools.inc'
      include           'iox.inc'
      include           'error.inc'
      integer           u, mode
      character*(*)     filename
c
      integer           flength, ios, falloc
c
      flength = leng(filename)
      u = falloc(u)
      fopen = u
c
      if (u.eq.ioerror) then
         continue
c
      else if (mode.eq.ioread) then
         open (unit   = u,
     &         file   = filename(1:flength),
     &         status = 'old',
     &         iostat = ios,
     &         err    = 10)
         access(u)=ioread
         bp(u)=0
         length(u)=0
c
      else if (mode.eq.iowrite) then
         open (unit   = u,
     &         file   = filename(1:flength),
     &         status = 'unknown',
     &         iostat = ios,
     &         err    = 10)
         access(u)=iowrite
         bp(u)=0
         length(u)=0
c
      else if (mode.eq.ioappend) then
         open (unit   = u,
     &         file   = filename(1:flength),
     &         status = 'old',
     &         iostat = ios,
     &         access = 'append',
     &         err    = 10)
         access(u)=iowrite
         bp(u)=0
         length(u)=0
c
      else if (mode.eq.iofortran) then
         open (unit   = u,
     &         file   = filename(1:flength),
     &         status = 'unknown',
     &         iostat = ios,
     &         err    = 10)
         access(u)=iofortran
         bp(u)=0
         length(u)=0
c
      else
         call fdealloc (u)
         call error ('fopen', 'Illegal access mode', warning)
         fopen=ioerror
      endif
c
      return
c
 10   call fdealloc (u)
      fopen=ioerror
      call error ('fopen', 'Error opening a file', warning)
      return
      end
