c
c-----------------------------------------------------------------------
c
      subroutine gcf (gammcf, a, x, gln)
c
c.....gcf - computes the complementary incomplete gamma function.
c
      include           'implicit.inc'
      include           'error.inc'
c
      real*8            gammcf, a, x, gln, gammln
c
      real*8            ERROR_VALUE, eps
      integer           itmax
      parameter         (ERROR_VALUE = 9.999999d29)
      parameter         (itmax = 100, eps = 3d-7)
      real*8            gold, a0, a1, b0, b1, fac, an, ana, anf, g
      integer           n
c
      gln = gammln(a)
      gold = 0d0
      a0 = 1d0
      a1 = x
      b0 = 0d0
      b1 = 1d0
      fac = 1d0
      do 11 n = 1, itmax
        an = dble(n)
        ana = an-a
        a0 = (a1+a0*ana)*fac
        b0 = (b1+b0*ana)*fac
        anf = an*fac
        a1 = x*a0+anf*a1
        b1 = x*b0+anf*b1
        if (a1.ne.0d0) then
          fac = 1d0/a1
          g = b1*fac
          if (abs((g-gold)/g).lt.eps) go to 1
          gold = g
        endif
11    continue
      gammcf = ERROR_VALUE
      call error ('gcf', 'a too large, itmax too small', warning)
      return
*1    gammcf = exp(-x+a*alog(x)-gln)*g
 1    gammcf = exp(-x+a*log(x)-gln)*g
      return
      end
