c
c.....pov.inc - Definition of parameters and data structures to be used
c     in the POV-Ray outputs.
c
      real*8  camangle(3)  !Position of the camera and aperture angle.
      real*8  zoom         !Large zoom factors for parallel projection.
      real*8  COP(3)       !Camera position
      real*8  SKY(3)       !Sky direction
      real*8  VUV(3)       !Up direction (should be the same as SKY)
      real*8  RHT(3)       !Right direction
      real*8  DRT(3)       !The 'third' direction
      real*8  VRP(3)       !Where the camera looks at
      logical usecamangle  !Use the camera angles settings?
      common /pov1/ camangle, zoom, COP, SKY, VUV, RHT, DRT, VRP
      common /pov1l/ usecamangle
c
c.....MISCELANEOUS ELEMENTS:
c
      logical putaxes      !Add reference axes to the scene?
      logical fullpov      !Output a complete scene?
      logical mirrors      !Add 3 plane mirrors?
      logical use_planes   !Output polyhedra as planes
      integer equalscale   !Controls the scaling of coordinates
      real*8  mirrx, mirry, mirrz  !Position of the mirrors
      common /pov2/ mirrx, mirry, mirrz,
     &              putaxes, fullpov, mirrors, equalscale, use_planes
c
c.....SCALE SETTINGS:
c
      integer scale_all, scale_xy, scale_yz, scale_xz, scale_none,
     &        scale_noscale
      parameter (scale_all     =  0)
      parameter (scale_xy      =  1)
      parameter (scale_yz      =  2)
      parameter (scale_xz      =  3)
      parameter (scale_none    =  4)
      parameter (scale_noscale = -1)
c
c.....NUMBERED TEXTURES:
c
      integer   MAXTEXT
      parameter (MAXTEXT = 30)
      character*(300) povtext(MAXTEXT)
      logical         usepovtext(MAXTEXT)
c
c.....TEXTURES:
c
      character*(300) def_texture
      character*(300) object_texture
      character*(300) stick_texture
      character*(300) ball_texture
      character*(300) polyhedron_texture
      character*(300) glass_texture
      character*(300) def_background
      character*(20)  obj_name, mol_name
      common /pov3/ def_texture, object_texture, stick_texture,
     &  ball_texture,  polyhedron_texture,  glass_texture,
     &  def_background, obj_name, mol_name, povtext
      common /pov3l/ usepovtext
c
c.....LIGHTS:
c
      integer   MLIGHT
      parameter (MLIGHT = 20)
      logical   def_light               !Use default lights?
      integer   n_light                 !Number of the max. light in use
      logical   use_light(MLIGHT)       !Is the light in use?
      real*8    r_light(MLIGHT)         !Coordinate r of the light
      real*8    theta_light(MLIGHT)     !Coordinate theta of the light
      real*8    phi_light(MLIGHT)       !Coordinate phi of the light
      character*(30) col_light(MLIGHT)  !Light color
c
      common /pov4/ r_light, theta_light, phi_light, use_light, n_light,
     &              def_light
      common /pov4s/ col_light
c
c.....ADDITIONAL ELEMENTS IN THE SCENE:
c
c     Type conventions (for sky, floor, ...):
c         0 = no element
c        -1 = use a file
c        >0 = use default element with this number
c
      integer         sky_type
      character*(80)  sky_file
      integer         floor_type
      character*(80)  floor_file
      integer         wall_type
      character*(80)  wall_file
      common /pov5i/ sky_type, floor_type, wall_type
      common /pov5s/ sky_file, floor_file, wall_file
