c
c-----------------------------------------------------------------------
c
      logical function precompile (n, line, lp)
c
c.....precompile - tokenize the expression contained in line and keep
c     it as the n-th expression. The lp line pointer indicates on input
c     the first character of line to analyze, and on output it points to
c     the last character used.
c
c GLOBAL DATA:
c
      include           'implicit.inc'
      include           'strtools.inc'
      include           'error.inc'
      include           'expr.inc'
      include           'opstack.inc'
      include           'tokens.inc'
c
c PARAMETERS:
c
      character*(*)     line
      integer           n, lp, ierr
c
c LOCAL VARIABLES:
c
      integer           leng, ierror, lpold
      logical           fnexttoken
c
c.....initialize number and operator stacks:
c
*mdc*if debug
*      write (6,600) n, line(lp:leng(line))
* 600  format (1x, 'PRECOMPILE: var= ', i9, ' expr= ', a)
*mdc*endif
      lpold = lp
      ierr = 0
      ntk = ntk + 1
      exprfirsttk(n) = ntk
      tktype(ntk) = tpnone
      do while ( fnexttoken (tknumval(ntk), tkoperator(ntk),
     &          tktype(ntk), line, lp, ierror) )
         tktype(ntk+1) = tktype(ntk)
         ntk = ntk + 1
         ierr = ierr + ierror
      enddo
      ntk = ntk - 1
      exprlasttk(n) = ntk
c
      if (ierr.eq.0) then
         precompile = .true.
      else
         lp = lpold
         precompile = .false.
      endif
      end
