c
c-----------------------------------------------------------------------
c
      real*8 function ran1 (idum)
c
c.....ran1 - Returns uniform random deviate numbers between 0.0 and 1.0.
c
c     Set idum to any negative value to initialize of reinitialize the
c     sequence.
c
c.....Routine described in: WH.Press, BP.Flannery, SA.Teukolsky, and
c     WT.Vetterling, Numerical Recipes (Cambridge, New York, 1986) p197.
c
      implicit none
      integer      idum
c
      integer      m1, ia1, ic1, m2, ia2, ic2, m3, ia3, ic3
      real*8       rm1, rm2
      parameter    (m1=259200,ia1=7141,ic1=54773,rm1=1.0/m1)
      parameter    (m2=134456,ia2=8121,ic2=28411,rm2=1.0/m2)
      parameter    (m3=243000,ia3=4561,ic3=51349)
      integer      iff, ix1, ix2, ix3, j
      real*8       r(97)
      save         r,ix1,ix2,ix3
c
c.....initialize on first call, even if idum is not negative:
c
      data iff /0/
      if (idum.lt.0 .or. iff.eq.0) then
         iff=1
c
c........the first routine is used to seed the second and third ones:
c
         ix1=mod(ic1-idum,m1)
         ix1=mod(ia1*ix1+ic1,m1)
         ix2=mod(ix2,m2)
         ix1=mod(ia1*ix1+ic1,m1)
         ix3=mod(ix1,m3)
c
c........fill the table with data generated by the first two routines:
c
         do 11 j=1,97
            ix1=mod(ia1*ix1+ic1,m1)
            ix2=mod(ia2*ix2+ic2,m2)
            r(j)=(ix1+ix2*rm2)*rm1
   11    continue
         idum=1
      endif
c
c.....generate next number for each sequence:
c
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix2=mod(ia3*ix3+ic3,m3)
c
c.....and determine what element of r() return:
c
      j=1+(97*ix3)/m3
      if (j.gt.97 .or. j.lt.1) stop 'error in ran2 function'
      ran1=r(j)
c
c.....refill the used table entry:
c
      r(j)=(ix1+ix2*rm2)*rm1
      return
      end
