c
c-----------------------------------------------------------------------
c
      subroutine readbb (file, uout, type)
c
c.....readbb - read the points contained in a BASIN (type=1) or
c     DBASIN (type=2) file.
c
      include           'implicit.inc'
      include           'error.inc'
      include           'polyhedron.inc'
      include           'strtools.inc'
c
      character*(*)     file
      integer           uout, type
c
      integer           luo, i, j, nedge, nface0, nn, nprop, npoint
      integer           idum(100)
      real*8            xdum
      character*(20)    dumi
      character*(80)    line
c
      integer           leng, fopen
      logical           commentline
c
c.....Open the input file:
c
      if (fopen (luo, file, ioread) .eq. ioread) then
         call error ('readbb', 'I/O error when opening data file',
     &               warning)
         return
      endif
c
c.....Skip initial comment lines:
c
      do while (commentline(luo,line))
         continue
      enddo
      read (luo,'(a)') dumi
c
c.....Read vertices first:
c
      isw1 = 0
      read (luo,*) nvert, nface(isw1), nedge
      if (type .eq. 1) then
         read (luo,*) nprop
         read (luo,'(a)') dumi
         do j = 1, nvert
            read (luo,*) xvert(j), yvert(j), zvert(j),
     &                   (xdum, i = 1, nprop)
         enddo
      else
         read (luo,*) npoint, xdum, xdum, xdum, xdum
         do j = 1, nvert
            read (luo,*) xvert(j), yvert(j), zvert(j),
     &                   (xdum, i = 1, npoint)
         enddo
      endif
c
c.....Read now the faces of the polyhedron:
c     Reduce all faces to triangles.
c
      nface0 = 0
      nvf = 3
      do j = 1, nface(isw1)
*         read (luo,*) nvf, (iface(i,j,isw1)-1, i = 1, nvf)
         read (luo,*) nn, (idum(i), i = 1, nn)
         do i = 2, nn-1
            nface0 = nface0 + 1
            iface(1,nface0,isw1) = idum(1)-1
            iface(2,nface0,isw1) = idum(i)-1
            iface(3,nface0,isw1) = idum(i+1)-1
         enddo
      enddo
      nface(isw1) = nface0
c
      call fclose (luo)
c
      write (uout,200) file(1:leng(file)), nvert, nvf, nface(isw1)
 200  format (/
     & 1x, 'READBB: reading a collection of sampling points'//
     & 1x, 'Name of the data file:       ', a/
     & 1x, 'Number of vertices created:  ', i6/
     & 1x, 'Number of vertices per face: ', i6/
     & 1x, 'Number of faces:             ', i6)
c
      end
