c
c.....spgcom.inc - symmetry information about the primitive cell.
c
c     laue ....... laue group number:
c                  1=1bar, 2=2/m, 3=mmm, 4=4/m, 5=4/mm, 6=r3r, 7=r3mr,
c                  8=3, 9=3m1, 10=31m, 11=6/m, 12=6/mmm, 13=m3, 14=m3m.
c     naxis ...... unique axis for monoclinic groups (1=x, ..3=z).
c     ncent ...... 1bar flag (0/1) for cs/non-cs (cs=centrosymmetric).
c     lcent ...... type of lattice centering:
c                  1=P, 2=A, 3=B, 4=C, 5=I, 6=F, 7=R.
c     neqv ....... number of symmetry matrices generated.
c     npol .......
c     jrt ........ nsym 3x4 codified rotation matrices.
c     ncv ........ number of centering vectors.
c     cen ........ lattice centering vectors.
c     rotm ....... decodified version of jrt.
c     lsys ....... crystallographic system: 1=triclinic, 2=monoclinic,
c                  3=orthorrombic, 4=tetragonal, 5=trigonal-R,
c                  6=trigonal-H, 7=hexagonal, 8=cubic.
c
      integer           laue, naxis, ncent, lcent, neqv, npol, jrt, ncv
      integer           lsys
      real*4            cen, rotm
      common /space /   laue, naxis, ncent, lcent, neqv, npol, lsys,
     &                  jrt(3,4,24), cen(3,4), ncv, rotm(3,4,24)
c
c.....Centering matrices for the real and reciprocal lattices:
c
      real*8            tocreal(7,3,3), tocrec(7,3,3)
      common /spac2/    tocreal, tocrec
